include masm32rt.inc
.586
include winmm.inc
includelib winmm.lib
inv equ invoke
.data
hpfreq  dq ?    ; high performance counter frequency
fstcnt  dq ?    ; starting timer count
endcnt  dq ?    ; ending timer count
tdelay  dd ?    ; multimedia timer delay wanted
tgot    dd ?    ; actual delay that occured
terr    dd ?
lcnt    dd ?
.data
t1000   dq 1000

.data?
buffx dd 100 dup (?)
mbuff equ offset buffx

.code

program:
    mov lcnt,10
    .repeat
        rdtsc
        and eax,127
        mov tdelay,eax
    	inv QueryPerformanceCounter,addr fstcnt
    	
        inv SleepEx,tdelay,0    
        
        inv QueryPerformanceCounter,addr endcnt
        inv QueryPerformanceFrequency,addr hpfreq
        finit
        fild endcnt
        fild fstcnt
        fsub
        fwait
        fild hpfreq
        fdiv
        fild t1000
        fmul
        fist tgot
        mov eax,tdelay
        sub eax,tgot
        mov terr,eax
        inv wsprintf,mbuff,SADD("Wanted %3li ms.  Got %3li ms.  Error= %3li ms."),tdelay,tgot,terr
        print mbuff,13,10
        dec lcnt
    .until zero?
    inkey SADD(13,10,"press any key to end")
    inv ExitProcess,0
end program
